/*
 * 20110720-05-3099.c
 */

#include <stdio.h>

/*
 *
 */

#define	EOS		'\0'

/*
 *
 */

/*
 * void echo_n_times_message ( char *message )
 *
 *	機能
 *		引数が空文字列の時には、「空文字列です」を一回だけ出力する
 *		引数で指定された文字列の先頭が数字の場合は、その後をその数字の表わす回数だけ繰り返す
 *		そうでなければ、一度だけ出力
 *	引数
 *		char * message : 出力する文字列
 *	返値
 *		void : なし
 */

void	echo_n_times_message ( char *message ) {

	if ( *message == EOS ) {		/* 空文字列だった */
		printf ( "空文字列です" );	/* 「空文字列です」を出力 */
	} else if ( *message == 'W' ) {	/* 先頭が 'W' で始まる */
		printf ( message + 1 );		/* 'W' を取り除いた残りを 2 度出力 */
		printf ( message + 1 );

	/*
	**	 この部分を完成させなさい
	*/

	} else {						/* そうでなかった */
		printf ( message );			/* 文字列をそのまま一度だけ出力 */
	}
}

/*
 *
 */

void check_echo_n_times_message ( char *message ) {

	printf ( "文字列 \"" );
	printf ( message );
	printf ( "\" を出力させると「" );

	echo_n_times_message ( message );

	printf ( "」になります。\n" );

}

/*
 *
 */

int main ( void ) {

	printf ( "\" abc\" の場合 : " );
	check_echo_n_times_message ( " abc" );

	printf ( "\" abc\" 先頭に 'W' を付けた場合 : " );
	check_echo_n_times_message ( "W abc" );

	printf ( "\" abc\" 先頭に 'y' を付けた場合 : " );
	check_echo_n_times_message ( "y abc" );

	printf ( "\"\" (空文字列) の場合 : " );
	check_echo_n_times_message ( "" );

	return 0;
}

/*
 *
 */

